<?php
//define(STORE_LOCATOR_WPRESS_ADMIN, 'store_locator_wpress_admin');


class Pricing_wpress_admin extends WPress_framework_pricing_wpress {
	
	function Pricing_wpress_admin() {
		add_action( 'admin_menu', array(__CLASS__, 'config_page_init') );
		add_action('admin_print_scripts', array(__CLASS__, 'config_page_scripts'));
		
		if($_GET['page']=='pricing-wpress-edit-content') {
			wp_enqueue_style( 'pricing_table_main', plugin_dir_url( __FILE__ ).'include/css/admin_main.css');
			wp_enqueue_style( 'pricing_table_style1', plugin_dir_url( __FILE__ ).'include/css/admin_style_1.css');
		}
		else {
			
			$style = $_GET['style'];
			if($style=='') {
				$_GET['style']=1;
				$style=1;
			}
			
			wp_enqueue_style( 'pricing_table_main', plugin_dir_url( __FILE__ ).'include/css/main.css');
			wp_enqueue_style( 'pricing_table_style1', plugin_dir_url( __FILE__ ).'include/css/style_'.$style.'.css');
		}
		
	}
	
	function config_page_scripts() {
		//wp_enqueue_script('dashboard');
		
		echo "
		<script type='text/javascript'> 
		/* <![CDATA[ */
		var Pricing_wpress = { 
		ajaxurl: '".admin_url('admin-ajax.php')."', admin_url: '".admin_url()."'
		};
		/* ]]> */
		</script> 
		";
		
		wp_enqueue_script('json2');
		
		wp_register_script('pricing_wpress_js', plugin_dir_url( __FILE__ ).'include/js/script.js', array('jquery'));
		wp_print_scripts('pricing_wpress_js');
	}
	
	function config_page_init() {
		if (function_exists('add_submenu_page')) {
			add_menu_page( 'Pricing WPress', 'Pricing WPress', 'manage_options', 'pricing-wpress', array(__CLASS__, 'display_pricing_wpress'), '', 8 );
			add_submenu_page('pricing-wpress', 'Add a table', 'Add a table', 'manage_options', 'pricing-wpress-add', array(__CLASS__, 'pricing_table_add'));
			add_submenu_page('pricing-wpress', '', '', 'manage_options', 'pricing-wpress-edit-structure', array(__CLASS__, 'pricing_table_edit_structure'));
			add_submenu_page('pricing-wpress', '', '', 'manage_options', 'pricing-wpress-edit-content', array(__CLASS__, 'pricing_table_edit_content'));
			add_submenu_page('pricing-wpress', '', '', 'manage_options', 'pricing-wpress-view', array(__CLASS__, 'pricing_table_view'));
			//add_submenu_page('pricing-wpress', '', '', 'manage_options', 'pricing-wpress-delete', array(__CLASS__, 'pricing_table_delete'));
		}
	}
	
	function display_pricing_wpress() {
		?>
		
		<div class="wrap">
		<div class="metabox-holder">
		<br>
		
		<?php
		$db1 = new Pricing_wpress_db();
		$tables = $db1->get_pricing_tables();
		
		echo '<h1>Pricing Tables list<font size="-1">';
		if(count($tables)>0) echo ' ( <a href="./admin.php?page=pricing-wpress-add">Add a table</a> )</font>';
		echo '</h1>';
		echo '<hr style="background:#ddd;color:#ddd;height:1px;border:none;">';
		
		for($i=0; $i<count($tables); $i++) {
			$id = $tables[$i]['id'];
			$name = $tables[$i]['name'];
			
			//echo '<p style="padding-bottom:10px; margin-bottom:10px; border-bottom: 1px solid #e7e7e7;">';
			
			echo '<table style="border-bottom: 1px solid #e7e7e7; width:100%;"><tr>';
			
			echo '<td><h2>'.$tables[$i]['name'].'</h2></td>';
			
			echo '<td align="right">';
			echo '
			<a href="./admin.php?page=pricing-wpress-view&id='.$id.'">Preview</a> - 
			<a href="./admin.php?page=pricing-wpress-edit-structure&id='.$id.'">Edit structure</a> - 
			<a href="./admin.php?page=pricing-wpress-edit-content&id='.$id.'">Edit content</a> - 
			<a href="#" id="'.$id.'" class="pt_delete_table_btn">Delete</a>';
			echo '</td>';
			
			echo '</tr></table>';
		}
		
		if(count($tables)==0) echo '<br>You don\'t have any pricing table yet: <a href="./admin.php?page=pricing-wpress-add">Add a new Pricing Table</a>';
		
		?>
		</div></div>
		<?php
	}
	
	function pricing_table_add() {
		?>
		
		<div class="wrap">
		<div class="metabox-holder">
		<br>
		
		<?php
		
		$nb_columns_tab = array('1'=>'1', '2'=>'2', '3'=>'3', '4'=>'4');
		$caption_column_state_tab = array(''=>'No', '1'=>'Yes');
		
		echo '<h1>Create a Pricing Table <font size="-1">( <a href="./admin.php?page=pricing-wpress">Back to the list</a> )</font></h1>';
		echo '<hr style="background:#ddd;color:#ddd;height:1px;border:none;">';
		
		echo '<form method="post">';
			
			echo '<input type="hidden" id="pt_id" value="">';
			
			echo '<p><label><b>Name</b></label></p>';
			echo '<p><input class="widefat" type="text" id="pt_name" style="width:440px;"></p>';
			
			echo '<p><label><b>Number of columns</b></label></p>';
			echo '<p><select id="pt_nb_columns" style="width:440px;">';
			foreach($nb_columns_tab as $ind=>$value) {
				if($nb_colums==$ind) echo '<option selected value="'.$ind.'">'.$value.'</option>';
				else echo '<option value="'.$ind.'">'.$value.'</option>';
			}
			echo '</select></p>';
			
			echo '<p><label><b>Number of lines</b></label></p>';
			echo '<p><input class="widefat" type="text" id="pt_nb_lines" style="width:440px;"></p>';
			
			echo '<p><h2>Optional settings</h2></p>';
			
			echo '<p><label>Line height (35 by default)</label></p>';
			echo '<p><input class="widefat" type="text" id="pt_line_height" style="width:440px;"></p>';
			
			echo '<p><label>Columns width (240 by default)</label></p>';
			echo '<p><input class="widefat" type="text" id="pt_columns_width" style="width:440px;"></p>';
		
			echo '<p><label>Caption column width (280 by default)</label></p>';
			echo '<p><input class="widefat" type="text" id="pt_caption_columns_width" style="width:440px;"></p>';
			
			echo '<p><label>Currency</label></p>';
			echo '<p><input class="widefat" type="text" id="pt_currency" style="width:440px;" value="'.$table['currency'].'"></p>';
			
			echo '<p><label>Disable the caption column</label></p>';
			echo '<p><select id="pt_caption_column_state" style="width:440px;">';
			foreach($caption_column_state_tab as $ind=>$value) {
				if($caption_column_state==$ind) echo '<option selected value="'.$ind.'">'.$value.'</option>';
				else echo '<option value="'.$ind.'">'.$value.'</option>';
			}
			echo '</select></p>';
			
			echo '<p class="submit" style="padding-bottom:0px; padding-top:0px;">';
			echo '<input class="button-primary" type="submit" id="pt_save_pricing_table_btn" value="Save and Continue"> - <a href="./admin.php?page=pricing-wpress">Cancel</a>';
			echo '</p>';
			
		echo '</form>';
		
		?>
		</div></div>
		<?php
	}
	
	function pricing_table_edit_structure() {
		?>
		
		<div class="wrap">
		<div class="metabox-holder">
		<br>
		
		<?php
		
		echo '<h1>Edit a Pricing Table Structure <font size="-1">( <a href="./admin.php?page=pricing-wpress">Back to the list</a> )</font></h1>';
		echo '<hr style="background:#ddd;color:#ddd;height:1px;border:none;">';
		
		$id = $_GET['id'];
		
		$db1 = new Pricing_wpress_db();
		$item = $db1->get_pricing_tables(array('id'=>$id));
		
		$nb_columns_tab = array('1'=>'1', '2'=>'2', '3'=>'3', '4'=>'4');
		$caption_column_state_tab = array(''=>'No', '1'=>'Yes');
		
		if(count($item)>0) {
			$table = $item[0]['pricing_table'];
			$table = json_decode($table,true);
			
			$nb_colums = $table['nb_columns'];
			$caption_column_state = $table['caption_column_state'];
			
			echo '<form method="post">';
			
				echo '<input type="hidden" id="pt_id" value="'.$item[0]['id'].'">';
				
				echo '<p><label><b>Name</b></label></p>';
				echo '<p><input class="widefat" type="text" id="pt_name" style="width:440px;" value="'.$item[0]['name'].'"></p>';
				
				echo '<p><label><b>Number of columns</b></label></p>';
				echo '<p><select id="pt_nb_columns" style="width:440px;">';
				foreach($nb_columns_tab as $ind=>$value) {
					if($nb_colums==$ind) echo '<option selected value="'.$ind.'">'.$value.'</option>';
					else echo '<option value="'.$ind.'">'.$value.'</option>';
				}
				echo '</select></p>';
				
				echo '<p><label><b>Number of lines</b></label></p>';
				echo '<p><input class="widefat" type="text" id="pt_nb_lines" style="width:440px;" value="'.$table['nb_lines'].'"></p>';
				
				echo '<p><h2>Optional settings</h2></p>';
				
				echo '<p><label>Line height (35 by default)</label></p>';
				echo '<p><input class="widefat" type="text" id="pt_line_height" style="width:440px;" value="'.$table['line_height'].'"></p>';
				
				echo '<p><label>Columns width (240 by default)</label></p>';
				echo '<p><input class="widefat" type="text" id="pt_columns_width" style="width:440px;" value="'.$table['columns_width'].'"></p>';
			
				echo '<p><label>Caption column width (280 by default)</label></p>';
				echo '<p><input class="widefat" type="text" id="pt_caption_columns_width" style="width:440px;" value="'.$table['caption_columns_width'].'"></p>';
				
				echo '<p><label>Currency</label></p>';
				echo '<p><input class="widefat" type="text" id="pt_currency" style="width:440px;" value="'.$table['currency'].'"></p>';
				
				echo '<p><label>Disable the caption column</label></p>';
				echo '<p><select id="pt_caption_column_state" style="width:440px;">';
				foreach($caption_column_state_tab as $ind=>$value) {
					if($caption_column_state==$ind) echo '<option selected value="'.$ind.'">'.$value.'</option>';
					else echo '<option value="'.$ind.'">'.$value.'</option>';
				}
				echo '</select></p>';
				
				echo '<p class="submit" style="padding-bottom:0px; padding-top:0px;">';
				echo '<input class="button-primary" type="submit" id="pt_save_pricing_table_btn" value="Save modifications"> - <a href="./admin.php?page=pricing-wpress">Cancel</a>';
				echo '</p>';
			
			echo '</form>';
		}
		else {
			echo '<p>No pricing table found with the given id.</p>';
			echo '<a href="./admin.php?page=pricing-wpress">Back to list</a>';
		}
		
		?>
		</div></div>
		<?php
	}
	
	function pricing_table_view() {
		?>
		
		<div class="wrap">
		<div class="metabox-holder">
		<br>
		
		<?php
		
		$id = $_GET['id'];
		
		$db1 = new Pricing_wpress_db();
		$pricing_table = $db1->get_pricing_tables(array('id'=>$id));
		
		echo '<h1>Preview a Pricing Table <font size="-1">( <a href="./admin.php?page=pricing-wpress-edit-content&id='.$id.'">Edit table content</a> - 
		<a href="./admin.php?page=pricing-wpress-edit-structure&id='.$id.'">Edit table structure</a> )</font></h1>';
		echo '<hr style="background:#ddd;color:#ddd;height:1px;border:none;">';
		
		if(count($pricing_table)>0) {
			$name = $pricing_table[0]['name'];
			$pricing_table = $pricing_table[0]['pricing_table'];
			
			$pricing_table = json_decode($pricing_table,true);
			
			$nb_columns = $pricing_table['nb_columns'];
			$nb_lines = $pricing_table['nb_lines'];
			$columns_width = $pricing_table['columns_width'];
			$caption_columns_width = $pricing_table['caption_columns_width'];
			$currency = '$';
			
			$table_content = $pricing_table['content'];
			
			$style=1;
			
			echo '<h2>Shortcode to use: <font color="blue"><i>[pricing_wpress id="'.$id.'" style="'.$_GET['style'].'"]</i></font></h2>';
			
			//style switcher
			$styles_list = array('1'=>'Style 1', '2'=>'Style 2', '3'=>'Style 3', '4'=>'Style 4', '5'=>'Style 5', '6'=>'Style 6', '7'=>'Style 7', '8'=>'Style 8');
			echo '<br>';
			echo '<form method="get">';
			echo '<h2>Preview with a different style: ';
			echo '<input type="hidden" name="page" value="'.$_GET['page'].'">';
			echo '<input type="hidden" name="id" value="'.$_GET['id'].'">';
			echo '<select name="style" onchange="form.submit()">';
			foreach($styles_list as $ind=>$value) {
				if($ind==$_GET['style']) echo '<option selected value="'.$ind.'">'.$value.'</option>';
				else echo '<option value="'.$ind.'">'.$value.'</option>';
			}
			echo '</select></h2>';
			echo '</form>';
			
			echo '<br><br>';
			
			//display table
			$d1 = new Pricing_wpress_display();
			$pricing_table = $d1->get_pricing_table($id);
			echo $pricing_table;
			
			echo '<div style="clear:both;"></div>';
			
			echo '<br><br>';
		}
		
		?>
		
		</div></div>
		<?php
	}
	
	function pricing_table_edit_content() {
		?>
		
		<div class="wrap">
		<div class="metabox-holder">
		<br>
		
		<?php
		
		$id = $_GET['id'];
		
		$db1 = new Pricing_wpress_db();
		$pricing_table = $db1->get_pricing_tables(array('id'=>$id));
		
		echo '<h1>Edit a Pricing Table content <font size="-1">( <a href="./admin.php?page=pricing-wpress">Back to the list</a> - 
		<a href="./admin.php?page=pricing-wpress-edit-structure&id='.$id.'">Edit table structure</a> )</font></h1>';
		echo '<hr style="background:#ddd;color:#ddd;height:1px;border:none;">';
		
		if(count($pricing_table)>0) {
			$name = $pricing_table[0]['name'];
			$pricing_table = $pricing_table[0]['pricing_table'];
			
			$pricing_table = json_decode($pricing_table,true);
			
			$nb_columns = $pricing_table['nb_columns'];
			$nb_lines = $pricing_table['nb_lines'];
			$columns_width = $pricing_table['columns_width'];
			$caption_columns_width = $pricing_table['caption_columns_width'];
			$currency = $pricing_table['currency'];
			$caption_column_state = $pricing_table['caption_column_state'];
			
			if($columns_width=='') $columns_width='220';
			if($caption_columns_width=='') $caption_columns_width='280';
			
			$table_content = $pricing_table['content'];
			
			echo '<h2>Name: '.$name.'</h2><br>';
			
			if($nb_columns>0 && $nb_lines>0 && $columns_width>0 && $caption_columns_width>0) {
				
				echo '<form method="post">';
				
				echo '<input type="hidden" id="pt_id" value="'.$id.'">';
				echo '<input type="hidden" id="pt_nb_columns" value="'.$nb_columns.'">';
				echo '<input type="hidden" id="pt_nb_lines" value="'.$nb_lines.'">';
				
				echo '<div class="p_table">';
					
					if($caption_column_state!='1') {
						//caption columns
						echo '<div class="caption_column" style="width:'.$caption_columns_width.'px;">';
							echo '<ul>';
								//column header
								echo '<li class="header_row_1 align_center radius5_topleft"></li>';
								//echo '<li class="header_row_2"><div class="caption hh2">choose <span>your</span> plan</div></li>';
								echo '<li class="header_row_2"><div class="caption hh2"><input id="pt_caption_header" value="'.$table_content['caption_header'].'" type="text" style="width:90%"></div></li>';
								//data rows
								for($i=1; $i<=$nb_lines; $i++) {
									if(is_array($table_content['caption_title'])) $caption_title = $table_content['caption_title'][$i];
									if(($i%2)==0) $class='row_style_2';
									else $class='row_style_4';
									echo '<li class="'.$class.'"><span><input id="pt_caption_title_'.$i.'" value="'.$caption_title.'" type="text" style="width:90%"></span></li>';
								}
								//column footer
								echo '<li class="footer_row"></li>';
							echo '</ul>';
						echo '</div>';
					}
					
					for($i=1; $i<=$nb_columns; $i++) {
						if(is_array($table_content['column_title'])) $column_title = $table_content['column_title'][$i];
						if(is_array($table_content['column_price'])) $column_price = $table_content['column_price'][$i];
						if(is_array($table_content['column_note'])) $column_note = $table_content['column_note'][$i];
						if(is_array($table_content['button_title'])) $button_title = $table_content['button_title'][$i];
						if(is_array($table_content['button_link'])) $button_link = $table_content['button_link'][$i];
						
						echo '<div class="column_'.$i.'" style="width:'.$columns_width.'px;">';
							echo '<ul>';
								echo '<li class="header_row_1 align_center"><div class="col1 hh2"><input id="pt_column_title_'.$i.'" value="'.$column_title.'" type="text" style="width:90%"></div></li>';
								echo '<li class="header_row_2 align_center"><div class="col1 hh1" style="margin-bottom:10px;"><span>
								<input id="pt_column_price_'.$i.'" value="'.$column_price.'" type="text" style="width:90%">
								</span></div><div class="col1 hh3">
								<input id="pt_column_note_'.$i.'" value="'.$column_note.'" type="text" style="width:90%">
								</div></li>';
								
								for($j=1; $j<=$nb_lines; $j++) {
									if(is_array($table_content['line'])) $line = $table_content['line'][$i][$j];
									
									if(($i%2)==0) {
										if(($j%2)==0) $class='row_style_2';
										else $class='row_style_4';
									}
									else {
										if(($j%2)==0) $class='row_style_1';
										else $class='row_style_3';
									}
									
									echo '<li class="'.$class.' align_center"><span><input id="pt_line_c'.$i.'_l'.$j.'" value="'.$line.'" type="text" style="width:90%"></span></li>';
								}
								
								echo '<li class="footer_row"><input id="pt_button_title_'.$i.'" value="'.$button_title.'" type="text" style="width:90%"></li>';
								echo '<li class="footer_row"><input id="pt_button_link_'.$i.'" value="'.$button_link.'" type="text" style="width:90%"></li>';
							echo '</ul>';
						echo '</div>';
					}
					
				echo '</div>';
				
				echo '<div style="clear:both;"></div><br><br>';
				
				echo '<p class="submit" style="padding-bottom:0px; padding-top:0px;">';
				echo '<input class="button-primary" type="submit" id="pt_save_content_btn" value="Save Pricing Table Content"> - <a href="./admin.php?page=pricing-wpress">Cancel</a>';
				echo '</p>';
				
				echo '</form>';
				
			}
			
		}
		else {
			echo '<p>No pricing table found with the given id.</p>';
			echo '<a href="./admin.php?page=pricing-wpress">Back to list</a>';
		}
		
		?>
		
		</div></div>
		<?php
	}
	
}

new Pricing_wpress_admin();

?>